public class Segment {
    public Point3D A, B;

    Segment(Point3D a, Point3D b) {
        A = a;
        B = b;
    }

    public int above(Segment other) {
        return above(this, other);
    }

    public static int above(Segment s1, Segment s2) {
        // First find the intersection in the 2D plane,
        // ignoring the height

        Point intersection = Point.segmentIntersection(s1.A.getXY(), s1.B.getXY(), s2.A.getXY(), s2.B.getXY());
        if (intersection == null) {
            // There is no intersection point, so nothing can be determined
            return 3;
        }

        double height1 = (intersection.x - s1.A.x) * (s1.B.z - s1.A.x) / (s1.B.x - s1.A.x) + s1.A.z;
        double height2 = (intersection.x - s2.A.x) * (s2.B.z - s2.A.x) / (s2.B.x - s2.A.x) + s2.A.z;

        if (height1 == height2) {
            return 0;
        }
        else if (height1 > height2) {
            return 1;
        }
        else /* if (height1 < height2) */ {
            return 2;
        }
    }
}
